/***********************************************************************
*                                                                      *
*  Example for the edit and abbreviation class                         *
*                                                                      *
*  Purpose : Input functions for edit                                  *
*                                                                      *
*  Author  : Peter Bloemendaal                                         *
*            Brainbox systems +31-70-3523661                           *
*  eMail   : internet -> bloemendaal@rullf2.LeidenUniv.nl              *
*            fidonet  -> 2:281/908                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*                                                                      *
* $Log: example.cpv $
// Revision 1.2  1994/08/25  20:08:34  BRAINBOX
// 1. Nice editor version with support for Output::setTerm function
//                                                                *
*                                                                      *
************************************************************************
*/
// Example for edit
// This example will take input from keyboard and direct sometimes to file
// and somtimes to an edit object.

#include "ABBREV.CPP"

class TestEdit : public AbbreviationEdit
{
   public:

      TestEdit(int x1, int y1, int x2, int y2, unsigned char *s)
         : AbbreviationEdit(x1, y1, x2, y2, s){ ; } ;
      int processKey(unsigned int)  ;
} ;


// Implement the pure virtual function from edit.hpp
int TestEdit::processKey(unsigned int key)
{
   switch (key)
   {
   case 9:
   case 10:
    return 0;

    default:
   printf("process key %i\n",key) ;
	 return 0 ;
  }
}


unsigned int _stklen = 32760;

void main(void)
{

	 int key1 ;
#if 0
	 int c ;
#endif
	 long lastpos = 0 ;                           // last filepointer position
	 FILE *in, *out ;

	 textattr((BLACK << 4) | WHITE) ;
	 clrscr() ;

#if 0
	 unsigned char st[8192] ; // I_A removed...

   strcpy(st,"" /* "This is a piece of text." */ ) ;

	 TestEdit edit1(5,5,75,20,st) ;               // Create the edit objects
#else
   TestEdit edit1(5,5,75,20, (unsigned char *)"This is a piece of text." ) ;             // Create the edit objects
#endif

	 edit1.loadFile("c:\\autoexec.bat") ;         // Load the autoexec.bat


	 edit1.setColor((C_LIGHTGRAY << 4) + C_BLUE) ;        // Set the color for an object

#if 0
	 edit1.setInput(INPUT_FILE) ;
	 edit1.setOutput(OUTPUT_FILE) ;
#endif
	 edit1.Output::setTerm(TERM_ANSI) ;
	 edit1.setBorder(1) ;
	 edit1.loadAbbreviation("abbrev.lst") ;

	 out = fopen(edit1.getInputFile(),"w+b") ;    // Open an output file for
																								// writing characters
   in  = fopen(edit1.getOutputFile(),"rb") ;
	 edit1.redraw() ;                             // Display the first editor

	 key1 = NULL ;
	 while (key1 != KEY_ESC )                     // Process the keys
	 {
			if ((key1 = edit1.poll()) != NULL)
				 edit1.interpKey(key1) ;

				 for ( ; lastpos < filelength(fileno(in)) ; lastpos++)
						printf("%c",fgetc(in)) ;

#if 0
				 c = getch() ;
				 if (!c)
				 {
						fprintf(out,"%c",c) ;
						c = getch() ;
						fprintf(out,"%c",c) ;

				 }
				 else
						fprintf(out,"%c",c) ;
#endif

				 fflush(out) ;

	 }
   fclose(out);
   fclose(in);  // I_A added
	 printf("\x1b[0m") ;
}
