/***********************************************************************
*                                                                      *
*  Definition file for OUTPUT.CPP                                      *
*                                                                      *
*  Purpose : Output functions for edit                                 *
*                                                                      *
*  Author  : Peter Bloemendaal                                         *
*            Brainbox systems +31-70-3523661                           *
*  eMail   : internet -> bloemendaal@rullf2.LeidenUniv.nl              *
*            fidonet  -> 2:281/908                                     *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*                                                                      *
* $Log: output.hpv $
// Revision 1.2  1994/08/25  20:07:14  BRAINBOX
// 1. Minor reconstructions
//
// Revision 1.1  1994/08/23  21:57:36  BRAINBOX
// Initial revision
//                                                                *
*                                                                      *
************************************************************************
*/

#define OUTPUT_NONE    0x00
#define OUTPUT_CON     0x01
#define OUTPUT_COM1    0x02
#define OUTPUT_COM2    0x04
#define OUTPUT_COM3    0x08
#define OUTPUT_COM4    0x10
#define OUTPUT_FILE    0x40


class Output : public Terminal
{
   protected:
      static int nr ;                  // Instance counter
      unsigned char outputmode ;
      FILE *fpOut ;
      char outputFilename[MAXPATH] ;   // File to print output to

      void outGotoxy(int x, int y) ;
      void outTextattr(unsigned char col) ;
      void outPrintf(char *st) ;
      void outChar(char c) ;

   public:
      Output::Output(void) ;
      void setOutput(unsigned int) ;
      unsigned int getOutput(void) ;
      char *getOutputFile(void) ;
      int  setOutputFile(char *fileName) ;
} ;
int Output::nr ;
